/*-------------------------------------------------------------
 *  Copyright (c) 2011-2014, MSS ComBlock. All rights reserved.
 *
 * 	Filename: RF.h
 *  Last modified: 4/15/14
 *  Authors:
 *  	Alain Zarembowitch / MSS ComBlock
 *  Version: 1.0
 *  Inheritance: N/A
 *  Description: RF components driver
 -------------------------------------------------------------*/
#ifndef RF_H_
#define RF_H_


/*-------- change this section according to the schematics ----------------------------------------*/
#define PIN_TX_EN2_H() FIO1SET = 0x00000001;    	// port1[0]
#define PIN_RFOUT_ENB2_H() FIO1SET = 0x00000002;	// port1[1]
#define PIN_RX_TXN2_H() FIO1SET = 0x00000010;    	// port1[4]
#define PIN_TX_RXN2_H() FIO1SET = 0x00000100;    	// port1[8]
#define PIN_LNA_ENB_H() FIO1SET = 0x00000200;    	// port1[9]

#define PIN_TX_EN2_L() FIO1CLR = 0x00000001;    	// port1[0]
#define PIN_RFOUT_ENB2_L() FIO1CLR = 0x00000002;	// port1[1]
#define PIN_RX_TXN2_L() FIO1CLR = 0x00000010;    	// port1[4]
#define PIN_TX_RXN2_L() FIO1CLR = 0x00000100;    	// port1[8]
#define PIN_LNA_ENB_L() FIO1CLR = 0x00000200;    	// port1[9]

#define PIN_AD7298_SCLK_H() FIO2SET = 0x00000040;    // port2[6]
#define PIN_AD7298_CSB_H() FIO2SET = 0x00000100;    // port2[8]
#define PIN_AD7298_DIN_H() FIO0SET = 0x00000001;    // port0[0]

#define PIN_AD7298_SCLK_L() FIO2CLR = 0x00000040;    // port2[6]
#define PIN_AD7298_CSB_L() FIO2CLR = 0x00000100;    // port2[8]
#define PIN_AD7298_DIN_L() FIO0CLR = 0x00000001;    // port0[0]

#define PIN_AD5621_1_SDIN_H() FIO2SET = 0x00000001;    // port2[0]
#define PIN_AD5621_1_SCLK_H() FIO2SET = 0x00000002;    // port2[1]
#define PIN_AD5621_1_SYNCB_H() FIO2SET = 0x00000004;    // port2[2]

#define PIN_AD5621_1_SDIN_L() FIO2CLR = 0x00000001;    // port2[0]
#define PIN_AD5621_1_SCLK_L() FIO2CLR = 0x00000002;    // port2[1]
#define PIN_AD5621_1_SYNCB_L() FIO2CLR = 0x00000004;    // port2[2]

#define PIN_AD5621_2_SDIN_H() FIO2SET = 0x00000008;    // port2[3]
#define PIN_AD5621_2_SCLK_H() FIO2SET = 0x00000010;    // port2[4]
#define PIN_AD5621_2_SYNCB_H() FIO2SET = 0x00000020;    // port2[5]

#define PIN_AD5621_2_SDIN_L() FIO2CLR = 0x00000008;    // port2[3]
#define PIN_AD5621_2_SCLK_L() FIO2CLR = 0x00000010;    // port2[4]
#define PIN_AD5621_2_SYNCB_L() FIO2CLR = 0x00000020;    // port2[5]

#define PIN_RFOUT_ENB_H() FIO1SET = 0x02000000; // port1[25]
#define PIN_RFOUT_ENB_L() FIO1CLR = 0x02000000; // port1[25]

/*-------- end of schematics-dependent code ----------------------------------------*/
extern long synth_check_lock(int);
extern unsigned long get_freq(long );
extern void adf4351_reg(long, int);
extern void init_tuner_pll(int, char);
extern void program_tuner_pll(int, char);
extern void RX_TXN_R_ISR(void);
extern void RX_TXN_F_ISR(void);
extern void RX_TXN_poll(void);
extern void setLNAgain(void);
extern void setRFGain(void);
extern void setIFGain(void);
extern void DAC_init(void);
extern void DAC(long);
extern void PWM_init(void);
extern void PWM11(long);
extern void p1_18(int);
extern void setTxGain(void);
extern void tx_gain_poll(void);
extern void LNA_AGC_poll(void);
extern void RF_AGC_poll(void);
extern void IF_AGC_poll(void);
extern void RF_gain_increment(void);
extern void RF_gain_decrement(void);
//extern long pinDiodeAttenuatorCompensation(long);
extern void ADC_init(void);
extern void setLPF(void);
extern void AD5621_1(int);
extern void AD5621_2(int);
extern void FFC_signals_poll(void);
extern void ADC_TX_POWER_DET(void);
extern void ADC_TEMP(void);
extern void ALC_poll(void);
extern void TP_poll(void);


#endif /* RF_H_ */
