/*-------------------------------------------------------------
 *  Copyright (c) 2010, MSS ComBlock. All rights reserved.
 *
 * 	Filename: uart.h
 *  Created on: Jun 23, 2010
 *  Last modified:
 *  Authors:
 *  	Alain Zarembowitch / MSS ComBlock
 *  Version: 1.0
 *  Inheritance: N/A
 *  Description: UART0 and UART3 configurations.
 *
 *  Dependencies/Pre-requisite: N/A
 -------------------------------------------------------------*/
#ifndef UART_H_
#define UART_H_

// return values
enum {
	UART_OK = 0,
	UART_ERXFULL,	// receive buffer overflow
	UART_EDATAIN,	// wrong input
	UART_ERXTOOFAST,	// messages are coming in faster than we are able to process
	UART_TXTIMEOUT,	// tx message too longer than the maximum
} uart_retvals;

extern void uart_init(void);
extern long uart_rxLineAppend(long);	// append chars from UART to rxLine
extern long uart_txpoll(void);		// send tx message from txLine to specified UART
//extern void UART0_IRQHandler(void);		// UARTn interrupt handler
//extern void UART3_IRQHandler(void);		// UARTn interrupt handler
extern long uart_rxpoll(void);			// service UARTS (polling)
extern long USB_ARM_mcrx(void);			// service USB via LPC17xx ARM
extern long USB_ARM_mctx(void);		// send tx message from txLine to USB via ARM
extern void USB_ARM_mctxint(void);	// callback routine called upon transmission of the last packet in the IN endpoint buffer

// global
extern long USB_ARM_EP82bufempty;

#endif /* UART_H_ */
