/*-------------------------------------------------------------
 *  Copyright (c) 2010-2015, MSS ComBlock. All rights reserved.
 *
 * 	Filename: utils.h
 *  Last modified: 12/12/15
 *  Authors:
 *  	Alain Zarembowitch / MSS ComBlock
 *  Version: 2
 *  Inheritance: N/A
 *  Description: Utilities for ARM Cortex-M3 LPC17xx
 *  Dependencies/Pre-requisite: N/A
 -------------------------------------------------------------*/
#ifndef UTILS_H_
#define UTILS_H_

/*-------- change this section according to the schematics ----------------------------------------*/
#define PIN_USB_CONNECTB_H() FIO1SET = 0x00400000;    	// port1[22]

#define PIN_USB_CONNECTB_L() FIO1CLR = 0x00400000;    	// port1[22]

#define PIN_RED_LED_H() FIO1SET = 0x00800000;	// port1[23]
#define PIN_RED_LED_L() FIO1CLR = 0x00800000;	// port1[23]
/*-------- end of schematics-dependent code ----------------------------------------*/

extern long JP1val;	// Jumper JP1 position 0(none), 12 or 23. Call JP1_jumper() to assess

// function prototypes
extern int power_check(void);
extern void delay_ms(unsigned long);	// delay in ms
extern void delay_ns(unsigned long);	// delay in ns
extern void sendLine(long);	// dispatch txLine to one of four possible output ports
extern void forwardLine(void);  // forward rx message in rxLine to other intended recipients
extern int dispatchLine(void);
extern unsigned char hex2bin(char istring[2]);
extern void char2hex(unsigned char, char * );
extern void toggle1(int);
extern void toggle2(int);
extern long get_JP1val(void);
extern void assess_JP1(void);
extern int USB_VBUS_check(void);
extern void USB_Connect (unsigned long);
extern void USB_connect_ctrl(void);

#endif /* UTILS_H_ */
